<template src="./template.html"></template>

<script lang="ts">
import { Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import { apiErrorHandler } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import _ from "lodash";

var momentz = require("moment-timezone");
var moment = require("moment");

@Component({
  components: {},
})
export default class AdminDashboardComponent extends Vue {
  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  page = 1;
  totalPage: number = 0;

  configProduct = {
    page: 1,
    limit: 25,
    search: "",
  };
  pageProduct = 1;
  totalPageProduct: number = 0;

  dateStartPicker = false;
  dateEndPicker = false;
  dateStart = momentz().startOf("month").format("YYYY-MM-DD");
  dateEnd = moment().endOf("day").format("YYYY-MM-DD");

  datePicker = false;

  chartType = "";
  listOrder = [];
  listProduct = [];
  loadingTable = false;
  loadingTableRecent = false;
  loadingTableOrder = false;

  beforeDestroy() {
    this.timeActive = "Today";
  }

  get stats() {
    return this.$store.state.manageStats.stats;
  }

  set stats(value: any) {
    this.$store.commit("manageStats/setStats", value);
  }

  get dateArr() {
    return this.$store.state.setting?.dateArr || [];
  }

  set dateArr(value: string[]) {
    this.$store.commit("setting/setDateArr", value);
  }

  get timeActive() {
    return this.$store.state.setting?.timeActive || "";
  }

  set timeActive(value: string) {
    this.$store.commit("setting/setTimeActive", value);
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get dateRangeText() {
    return this.dateArr.join("~");
  }

  limitItems = [5, , 10, , 15, , 20, , 25, , 30, , 35, , 40];
  sortViewContent = false;
  sortAddToCart = false;
  sortCheckout = false;
  sortInitiate = false;
  sortRevenue = false;
  sortPurchase = false;
  sortProductCost = false;
  sortConversionRate = false;
  sortProfit = false;
  sortAov = false;
  sortPcre = false;

  created() {
    this.$store.commit("manageStats/setStatsEachPage", "dashboard-admin");
    this.$store.commit("setting/setTime", {
      dateStart: this.dateStart,
      dateEnd: this.dateEnd,
    });
  }

  mounted() {
    this.onFilterByTime("Today");
  }

  onSortTableHighToLowListProduct(insert: string) {
    const listProduct = [...this.listProduct];
    this.listProduct = this.$utils.sortList(listProduct, insert, "highToLow");
    if (insert === "viewContent") {
      this.sortViewContent = false;
    }
    if (insert === "addToCart") {
      this.sortAddToCart = false;
    }
    if (insert === "checkout") {
      this.sortCheckout = false;
    }

    if (insert === "goCheckout") {
      this.sortInitiate = false;
    }

    if (insert === "revenue") {
      this.sortRevenue = false;
    }
    if (insert === "purchase") {
      this.sortPurchase = false;
    }
    if (insert === "productCost") {
      this.sortProductCost = false;
    }
    if (insert === "conversionRate") {
      this.sortConversionRate = false;
    }
    if (insert === "profit") {
      this.sortProfit = false;
    }
    if (insert === "aov") {
      this.sortAov = false;
    }
    if (insert === "pcre") {
      this.sortPcre = false;
    }
  }

  onSortTableLowToHighListProduct(insert: string) {
    const listProduct = [...this.listProduct];
    this.listProduct = this.$utils.sortList(listProduct, insert, "lowToHigh");
    this.checkValueSortListProduct(insert);
  }

  checkValueSortListProduct(insert: string) {
    this.sortViewContent = insert === "viewContent";
    this.sortAddToCart = insert === "addToCart";
    this.sortCheckout = insert === "checkout";
    this.sortInitiate = insert === "goCheckout";
    this.sortRevenue = insert === "revenue";
    this.sortPurchase = insert === "purchase";
    this.sortProductCost = insert === "productCost";
    this.sortConversionRate = insert === "conversionRate";
    this.sortProfit = insert === "profit";
    this.sortAov = insert === "aov";
    this.sortPcre = insert === "pcre";
  }

  onRefresh() {
    this.onFilterByTime("Today");
  }

  async onGetListProduct() {
    try {
      this.loadingTableRecent = true;
      const response = await this.$api.stats.getRecent({
        from: this.from,
        to: this.to,
        timezone: this.timezone,
        ...this.configProduct,
      });
      const { total } = response.data;
      this.totalPageProduct = Math.ceil(total / this.configProduct.limit);
      if (response?.data?.data) {
        response.data.data.forEach((item: any) => {
          item.profit = item.revenue - item.productCost || 0;
          item.aov = item.revenue / item.purchase || 0;
          item.pcre = item.productCost / item.revenue || 0;
        });
        this.listProduct = response.data.data;
        this.sortViewContent = false;
        this.sortAddToCart = false;
        this.sortCheckout = false;
        this.sortInitiate = false;
        this.sortRevenue = false;
        this.sortPurchase = false;
        this.sortProductCost = false;
        this.sortConversionRate = false;
        this.sortProfit = false;
        this.sortAov = false;
        this.sortPcre = false;
      }
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableRecent = false;
    }
  }

  async onGetListOrder() {
    try {
      this.loadingTableOrder = true;
      const response = await this.$api.order.getListOrder({
        from: this.from,
        to: this.to,
        timezone: this.timezone,
        ...this.config,
      });
      const { total } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        response.data.data.forEach((item: any) => {
          item.emailShippingAddress = item.shippingAddress.email || "";
        });
        this.listOrder = response.data.data;
      }
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
    }
    this.loadingTableOrder = false;
  }

  async onGetListByTime() {
    try {
      this.loadingTable = true;
      const response = await this.$api.stats.getByTime({
        from: this.from,
        to: this.to,
        timezone: this.timezone,
      });
      if (response?.data) {
        this.$store.commit("manageStats/parseStats", response.data);
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  onHandleSearch() {
    this.$store.commit("setting/setTime", {
      dateStart: this.dateRangeText.split("~")[0],
      dateEnd: this.dateRangeText.split("~")[1],
    });
    this.onGetAllList();
    this.timeActive = "";
  }

  onFilterByTime(time: string) {
    this.$store.commit("setting/setFilterByTime", { time });
    this.onGetAllList();
  }
  async onGetAllList() {
    const proms = [
      this.onGetListProduct(),
      this.onGetListByTime(),
      this.onGetListOrder(),
    ];
    await Promise.all(proms);
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListOrder();
  }

  onRedirectPageProduct() {
    this.configProduct.page = this.pageProduct;
    this.onGetListProduct();
  }

  formatDate(createdAt: Date) {
    const timezone = this.$store.state.setting?.siteInfo?.timezone || "-7";
    const unix = moment(createdAt).unix() * 1000 + timezone * 60 * 60 * 1000;
    return moment(unix).utc().format("HH:mm DD/MM/YYYY");
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  async onCopySlug(slug: string) {
    try {
      const link = await this.linkProduct(slug);
      return link;
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  linkProduct(slug: string) {
    const domain = window.location.host;
    return `${slug}.${domain}`;
  }

  showTypeStats(type: string) {
    if (
      type === "revenue" ||
      type === "productCost" ||
      type === "profit" ||
      type === "aov"
    ) {
      {
        return "usd";
      }
    } else if (type === "conversionRate" || type === "PCRE") {
      return "percent";
    }
    return "";
  }

  parseTipNumber(evt: any) {
    evt = evt ? evt : window.event;
    let expect = evt.target.value.toString() + evt.key.toString();

    if (!/^[-+]?[0-9]*\.?[0-9]*$/.test(expect)) {
      evt.preventDefault();
    } else {
      return true;
    }
  }

  @Watch("config.page")
  changedPage() {
    this.onGetListOrder();
  }

  @Watch("configProduct.page")
  changedPageProduct() {
    this.onGetListProduct();
  }
}
</script>

<style lang="scss">
#admin-dashboard {
  .v-input__slot {
    box-shadow: unset !important;
  }
}
#hideBottomInput #inputDate .v-text-field__slot input {
  color: #333d4d;
  font-weight: 600;
  font-size: 16px;
  line-height: 24px;
}

.btn-active-filter-time {
  background-color: #0ab54e !important;
}

.btn-active-filter-time p {
  color: #fff !important;
}

.width-card-overview {
  width: 19%;
}

@media screen and (max-width: 420px) {
  .width-card-overview {
    width: 100%;
  }
}

@media screen and (min-width: 1024px) {
  .width-card-overview {
    width: 19%;
  }
}
</style>
